(in-package :user)

;;; Homework set 2-1
;;; Exercise #7: Macros

;;; 7A] Write some macros that help generate HTML
;;;     Send output to *standard-output*
;;;     (as center "Lisp Class")
;;;     - <center>Lisp Class</center>

;;; First, write a helper-function
(defun output-tag (tagname &key (final nil))
  (if final
      (format *standard-output* "</~A>" tagname)
    (format *standard-output* "<~A>" tagname)))

(defmacro as (tag content)
  `(let ((tag-val ',tag))
     (output-tag tag-val)
     (format *standard-output* "~A" ,content)
     (output-tag tag-val :final t)
     ))

;;; 7B] (with center (princ "Lisp") (princ " Class"))
;;;     - <center>
;;;     - Lisp Class
;;;     - </center>
(defmacro with (tag &body body)
  `(let ((tag-val ',tag))
     (output-tag tag-val)
     (terpri *standard-output*)
     ,@body
     (terpri *standard-output*)
     (output-tag tag-val :final t)
     ))
