(in-package :user)

;;; Homework set 2-1
;;; Exercise #2: setf


;;; 2A] Write a setf function on third that does this:
;;;     (setq list '(1 2 3 4 5 6))
;;;     (setf (third list) 7)
;;;     list
;;;     = (1 2 7 4 5 6)


;;; First, define my own "third" function.
(defun my-third (my-list)
  (nth 2 my-list))

;;; Then define a corresponding setf form
(defun (setf my-third) (new list)
  ;; Do some simple error checking on the input.
  (cond ((not (listp list))
	   (error "~S is not a list." list))
	  ((< (length list) 3)
	   (error "~S is a less of fewer than three elements" list))
	  (t 
	   (rplaca (cdr (cdr list)) new)))
  list)
